/**************************************************************************/
/* File: boardslist.c - list to translate hardware option to board struct */
/*                                                                        */
/* LinCAN - (Not only) Linux CAN bus driver                               */
/* Copyright (C) 2002-2009 DCE FEE CTU Prague <http://dce.felk.cvut.cz>   */
/* Copyright (C) 2002-2009 Pavel Pisa <pisa@cmp.felk.cvut.cz>             */
/* Funded by OCERA and FRESCOR IST projects                               */
/* Based on CAN driver code by Arnaud Westenberg <arnaud@wanadoo.nl>      */
/*                                                                        */
/* LinCAN is free software; you can redistribute it and/or modify it      */
/* under terms of the GNU General Public License as published by the      */
/* Free Software Foundation; either version 2, or (at your option) any    */
/* later version.  LinCAN is distributed in the hope that it will be      */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty    */
/* of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU    */
/* General Public License for more details. You should have received a    */
/* copy of the GNU General Public License along with LinCAN; see file     */
/* COPYING. If not, write to the Free Software Foundation, 675 Mass Ave,  */
/* Cambridge, MA 02139, USA.                                              */
/*                                                                        */
/* To allow use of LinCAN in the compact embedded systems firmware        */
/* and RT-executives (RTEMS for example), main authors agree with next    */
/* special exception:                                                     */
/*                                                                        */
/* Including LinCAN header files in a file, instantiating LinCAN generics */
/* or templates, or linking other files with LinCAN objects to produce    */
/* an application image/executable, does not by itself cause the          */
/* resulting application image/executable to be covered by                */
/* the GNU General Public License.                                        */
/* This exception does not however invalidate any other reasons           */
/* why the executable file might be covered by the GNU Public License.    */
/* Publication of enhanced or derived LinCAN files is required although.  */
/**************************************************************************/

#include "../include/can.h"
#include "../include/can_sysdep.h"
#include "../include/main.h"

extern int template_register(struct hwspecops_t *hwspecops);
extern int virtual_register(struct hwspecops_t *hwspecops);
extern int oscar_register(struct hwspecops_t *hwspecops);
extern int pip_register(struct hwspecops_t *hwspecops);
extern int m437_register(struct hwspecops_t *hwspecops);
extern int smartcan_register(struct hwspecops_t *hwspecops);
extern int pccanf_register(struct hwspecops_t *hwspecops);
extern int pccand_register(struct hwspecops_t *hwspecops);
extern int pccanq_register(struct hwspecops_t *hwspecops);
extern int kv_pcican_register(struct hwspecops_t *hwspecops);
extern int ems_cpcpci_register(struct hwspecops_t *hwspecops);
extern int nsi_register(struct hwspecops_t *hwspecops);
extern int cc104_register(struct hwspecops_t *hwspecops);
extern int pci03_register(struct hwspecops_t *hwspecops);
extern int pcm3680_register(struct hwspecops_t *hwspecops);
extern int aim104_register(struct hwspecops_t *hwspecops);
extern int pcccan_register(struct hwspecops_t *hwspecops);
extern int ssv_register(struct hwspecops_t *hwspecops);
extern int bfadcan_register(struct hwspecops_t *hwspecops);
extern int gensja1000mm_register(struct hwspecops_t *hwspecops);
extern int gensja1000io_register(struct hwspecops_t *hwspecops);
extern int pimx1_register(struct hwspecops_t *hwspecops);
extern int msmcan_register(struct hwspecops_t *hwspecops);
extern int unican_register(struct hwspecops_t *hwspecops);
extern int unican_pci_register(struct hwspecops_t *hwspecops);
extern int unican_vme_register(struct hwspecops_t *hwspecops);
extern int ipci165_register(struct hwspecops_t *hwspecops);
extern int pcan_dongle_register(struct hwspecops_t *hwspecops);
extern int eb8245_register(struct hwspecops_t *hwspecops);
extern int adlink7841_register(struct hwspecops_t *hwspecops);
extern int tscan1_register(struct hwspecops_t *hwspecops);
extern int tscan1mmio_register(struct hwspecops_t *hwspecops);
extern int ts7kv_register(struct hwspecops_t *hwspecops);
extern int ns_dev_register(struct hwspecops_t *hwspecops);
extern int hms30c7202_register(struct hwspecops_t *hwspecops);
extern int nsi_canpci_register(struct hwspecops_t *hwspecops);
extern int usbcan_register(struct hwspecops_t *hwspecops);
extern int omap2_spican_register(struct hwspecops_t *hwspecops);
extern int pcan_pci_register(struct hwspecops_t *hwspecops);
extern int esdpci200_register(struct hwspecops_t *hwspecops);
extern int esdpci266_register(struct hwspecops_t *hwspecops);
extern int sh7760_register(struct hwspecops_t *hwspecops);
extern int mpc5200_register(struct hwspecops_t *hwspecops);
extern int mpc5200_midam_register(struct hwspecops_t *hwspecops);

const struct boardtype_t can_boardtypes[]={
    #ifdef CONFIG_OC_LINCAN_CARD_template
	{"template", template_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_virtual
	{"virtual", virtual_register, 0},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_oscar
	{"oscar", oscar_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pip
	{"pip5", pip_register, 1},
	{"pip6", pip_register, 1},
	{"pip7", pip_register, 1},
	{"pip8", pip_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_smartcan
	{"smartcan", smartcan_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_nsi
	{"nsican", nsi_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_cc_can104
	{"cc104", cc104_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_aim104
	{"aim104", aim104_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pc_i03
	{"pc-i03", pci03_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pcm3680
	{"pcm3680", pcm3680_register, 2},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pccan
	{"pccan-f", pccanf_register, 1},
	{"pccan-s", pccanf_register, 1},
	{"pccan-d", pccand_register, 2},
	{"pccan-q", pccanq_register, 4},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_kv_pcican)&&defined(CAN_ENABLE_PCI_SUPPORT)
	{"pcican-s", kv_pcican_register, 0},
	{"pcican-d", kv_pcican_register, 0},
	{"pcican-q", kv_pcican_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_ems_cpcpci)&&defined(CAN_ENABLE_PCI_SUPPORT)
	{"ems_cpcpci", ems_cpcpci_register, 0},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_m437
	{"m437", m437_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pcccan
	{"pcccan", pcccan_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_ssv
	{"ssv",	ssv_register, 2},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_bfadcan
	{"bfadcan", bfadcan_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_gensja1000mm
	{"gensja1000mm", gensja1000mm_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_gensja1000io
	{"gensja1000io", gensja1000io_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_pimx1
	{"pimx1", pimx1_register, 0},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_msmcan
	{"msmcan", msmcan_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_unican
	{"unican", unican_register, 1},
    #endif
    #ifdef CONFIG_OC_LINCAN_CARD_ipci165
	{"ipci165", ipci165_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_unican)&&defined(CAN_ENABLE_PCI_SUPPORT)
	{"unican-pci", unican_pci_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_unican)&&defined(CAN_ENABLE_VME_SUPPORT)
	{"unican-vme", unican_vme_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_pcan_dongle)
	{"pcan_dongle", pcan_dongle_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_eb8245)
	{"eb8245", eb8245_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_adlink7841)
	{"adlink7841", adlink7841_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_esdpci200)
	{"esdpci200", esdpci200_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_esdpci266)
	{"esdpci266", esdpci200_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_tscan1)
	{"tscan1", tscan1_register, 1},
	{"tscan1mmio", tscan1mmio_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_ts7kv)
	{"ts7kv",  ts7kv_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_ns_dev_can)
	{"ns_dev", ns_dev_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_sh7760)
	{"sh7760", sh7760_register, 2},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_hms30c7202_can)
	{"hms30c7202", hms30c7202_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_nsi_canpci)&&defined(CAN_ENABLE_PCI_SUPPORT)
	{"nsicanpci", nsi_canpci_register, 1},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_pcan_pci)&&defined(CAN_ENABLE_PCI_SUPPORT)
	{"pcan_pci", pcan_pci_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_usbcan)
	{"usbcan", usbcan_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_omap2_spican)
	{"omap2_spican", omap2_spican_register, 0},
    #endif
    #if defined(CONFIG_OC_LINCAN_CARD_mpc5200)
	{"mpc5200", mpc5200_register, 0},
	{"mpc5200_midam", mpc5200_midam_register, 0},
    #endif
 	{NULL}
};

const struct boardtype_t* boardtype_find(const char *str)
{
	const struct boardtype_t *brp;

	for(brp=can_boardtypes;brp->boardtype;brp++) {
		if(!strcmp(str,brp->boardtype))
			return brp;
	}

	return NULL;
}
